########
# Gros pb avec \be \ee etc
# limination des \ecom par exemple
# revoir les pbs d'ambiguites ventuelles et utiliser des caractres  etc pour les
# symboles sur 2 caractres comme /* et */ etc
## volution ##################################################################
# $Log: a8_tex.sed,v $
# Revision 2.7  1997/09/06 10:41:12  rr
# traitement correct des squences .^[ .^] |^[ |^]
# amlioration des commentaires de traitement du `_'
#
# Revision 2.3  1996/09/19 06:04:46  rr
# petites modifs
#
# Revision 2.2  1996/02/22 13:23:58  rr
# version a peu pres OK apres passage a nrtex/nitex
#
# Revision 2.1  1996/02/11 20:32:03  rr
# nouvelle version pour les polices avec signe paragraph au lieu de % pour les polices.
# Autres conventions pour faciliter le traitement par hilit19.el
#

################################################################################

# $Id: a8_tex.sed,v 2.7 1997/09/06 10:41:12 rr Exp rr $

# Description ------------------------------------------------------------------

# Ce filtre ne traduit plus les lettres accentues qui doivent tre directement
# mises au moteur tex 8 bits, en codage iso-latin1 cad T1 pour Latex

# Attention !!!! la traduction de certains symboles se fait directement en
# encodage DC/T1/Cork : Ne pas utiliser OT1 !!!
# (Ceci vite d'utiliser \verb|...| qui impose une famille \tt)

# Cela fait gagner du temps de traduction et limite la ncessit de ce filtre
# On libre aussi des commandes pour allger sed qui tait au bord de
# l'puisement dans la version 1.15

# Conventions de quoting

# 1) `' inhibiteur (sous emacs/diacritic, taper X^) ou `' (obsolte) = 
#    caractre vide, limin  la fin de ce script.
#    Sert  quoter toute squence spciale :
#    il suffit de l'intercaler dans une squence.
#    Exemples : oe vite la traduction de oe comme une ligature {\oe}
#               ... -> ... et non \ldots (en mode verbatim par exemple)
# 2) `' forceur 1, sert  quoter n'importe quel caractre spcial de Latex2e
# (sous emacs/diacritic, taper `|^' pour obtenir `')
# SANS CHANGER DE POLICE
#  # $ % & ~ _ ^ \ { } + = | < > @
#
# 3) `' forceur 2, sert  quoter n'importe quel caractre spcial de Latex2e
# (sous emacs/diacritic, taper `.^' pour obtenir `' (point centr) )
# AVEC POLICE \ttfamily
#  # $ % & ~ _ ^ \ { } + = | < > @
#
# 4) `' (prononcer pol comme police), remplace % dans les commandes de polices 
#        (sous emacs/diacritic, taper P^ ou AltGraph)
#
# 5) `'  (compose AE sous emacs-diacritic) ou 
#     `' (compose ae sous emacs-diacritic) -> \AE ou \ae
#    `E' (compose OE sous emacs-diacritic) ou 
#    `e' (compose oe sous emacs-diacritic) -> \OE ou \oe
# --------------------------------------------------------------------------------

# Attention !!!
# * Tous les encodages directs ne sont valables qu'avec l'encodage T1
#        (compatible avec les polices mf et postscript)
# * Lorsqu'on utilise la commande \symbol et un code hexa, il faut des MAJUSCULES

####################################################################################

# Traitement du champs d'identification RCS : $Id: a8_tex.sed,v 2.7 1997/09/06 10:41:12 rr Exp rr $

s|\$Id: \([^,]*\),v \([^ ]*\) |S \1 v\2 #|
s|#\([^/]*\)/\([^/]*\)/\([^ ]*\) \([^:]*\):\([^:]*\):\([^ ]*\) | \3/\2/\1 \4:\5#|

# \1 devrait correspondre au login du createur de la base : sans interet ici
# \3 devrait correspondre au login de l'auteur de la derniere modif ( lockeur )

s|#\([^ ]*\) \([^ ]*\) \([^ ]*\) *\$| \2 \3s|

# bug de sed SunOS : \ec ne marche pas dans les rgles gnrales
s/\\ec$/\\end{center}/g
s/\\ec\([^a-z]\)/\\end{center}\1/g

# Traduction des \begin{... ou \end{... abrgs 
# @@ Mis ici tant qu'on traduit \xxx{...} -> \xxx{zzz} dans les programmes
s/\\B{/\\begin{/g
s/\\E{/\\end{/g

### traduction de quelques signes problmatiques dans les programmes en C
# @@ trs exprimental !!!

/^[^%]*\\bP/,/\\eP/{
# Pour des raisons mystrieuses, "<<" et ">>" ne marchent pas en mode tabbing
# si les deux signes  ...  ne sont pas sur la mme ligne
		s//\\symbol{"13}/g
		s//\\symbol{"14}/g
# ne pas  toucher aux lignes \bP et \eP
       /^[^%]*\\[eb]P/b suite02
# traduction \xxx{...} -> \xxx{...} dans les programmes
       s/\(\\[a-zA-Z]*\){\([^}]*\)}/\1{\2}/g
# traduction \xxx{...}{...} -> \xxx{...}{...} dans les programmes
       s/\(\\[a-zA-Z]*\){\([^]*\)}{\([^}]*\)}/\1{\2}{\3}/g
# traduction \n et \t
       s/\([^]\)\\\([nt]\)/\1\\\2/g
# traduction des signes #%&{}~^+=|<>@ non prcds de `' ou `\' ou `' ou `'
# On ne traduit pas le $ pour permettre des formules mathmatiques
# On tolre les suites de caractres spciaux comme && || etc
# Donc ne quoter que le premier si ncessaire
       s/\([^\\]\)\([#%&{}~^+=|<>@]\)\([#%&{}~^+=|<>@]\)/\1\2\3/g
       s/\([^\\]\)\([#%&{}~^+=|<>@]\)/\1\2/g
# Traduction des mmes signes, mais en dbut de ligne
       s/^\([#%&{}~^+=|<>@]\)\([#%&{}~^+=|<>@]\)/\1\2/g
       s/^\([#%&{}~^+=|<>@]\)/\1/g

# traduction des commentaires  la C sur une ligne
# Pour ne pas avoir d'ambiguts dans les expressions rgulires, on traduit
# les symboles '/*' par \201 et '*/' par \202
s|/\*||g
s|\*/||g
s/\([^]*\)/{\\bcom \1 \\ecom}/g
# traduction des commentaires  la C <tab>/*
#                                    <tab> *
#                                    <tab> */

# Bcom
s|^\([	 ]*\)|\1\\Bcom |
# Ccom
       /^\([	]*\) *\*/{
			s|^\([^*]*\) *\*\([^/].*\)|\1\\Ccom \2|
			s|^\([^*]*\)\*$|\1\\Ccom|
# traduction de toutes les tabulations apres `*' par TAB\comfont
# On sauvegarde les tabulations de tete ( vrai dire inutile) MERDIQUE
			s/^				//
			s/^			//
			s/^		//
			s/^	//
# On traduit les tabulations en leur ajoutant \comfont
# (a irait aussi pour celles de tte)
			s/	/	\\comfont /g
# On restaure les tabulations de tte
			s//	/g
		}
# Ecom
		 s|^\([	]*\) *|\1\\Ecom |
# b suite01
}
### fin exprimental

: suite00

# 1) caractres spciaux dans la police en cours #%&_{} ~^\+=|<>@ est trait de 2 faons :

# 1.1)  #$%&_{}

s/\([#$%&_{}]\)/\\\1/g

# 2.1)  ~^\+=|<>@
# Cette traduction avec \symbol est valable pour presque tous les encodages (USASCII)
s/~/\\~{}/g
s/^/\\^{}/g
s/\\/\\symbol{"5C}/g
s/+/\\symbol{"2B}/g
s/=/\\symbol{"3D}/g
s/|/\\symbol{"7C}/g
s/</\\symbol{"3C}/g
s/>/\\symbol{"3E}/g
s/@/\\symbol{"40}/g
s/\[/\\symbol{"5B}/g
s/]/\\symbol{"5D}/g


: suite01
# 2) caractres spciaux dans la police \tt

# Cette traduction avec \symbol est valable pour presque tous les encodages (USASCII)
s/\([#$%&_{}]\)/\\texttt{\\\1}/g
s//$\\cdot$/g
s/~/\\texttt{\\~{}}/g
s/^/\\texttt{\\^{}}/g
s/\\/\\texttt{\\symbol{"5C}}/g
s/+/\\texttt{\\symbol{"2B}}/g
s/=/\\texttt{\\symbol{"3D}}/g
s/|/\\texttt{\\symbol{"7C}}/g
s/</\\texttt{\\symbol{"3C}}/g
s/>/\\texttt{\\symbol{"3E}}/g
s/@/\\texttt{\\symbol{"40}}/g
s/\[/\\texttt{\\symbol{"5B}}/g
s/]/\\texttt{\\symbol{"5D}}/g

: suite02
# Pour les transparents, les planches sont spares par ^L qu'on limine

s///g

# Multiplicateurs de tabulations Vraiment utilis ?

s/<5T>/\\>\\>\\>\\>\\>/g
s/<10T>/\\>\\>\\>\\>\\>\\>\\>\\>\\>\\>/g

# Mise en commentaires d'une rgion, sans modifier les numros de ligne

/^\\BL*C/,/^\\EL*C/s/^/% /

# Dbut du traitement gnral du texte en rtex ------------------------------

# Traduction de certains signes indispensables en mode non verbatim

s/\\i\([ []\)/\\item\1/g
s/\\i$/\\item/g

# Les vrais \> \< \|

s/\\<//g
s/\\>//g
s/\\|//g

# Signes  ne pas traduire en mode verbatim

/^\\bV/,/^\\eV/b suite

# s/\.\.\./\\ldots/g # Pour french ! @ revoir ... Et en mode english ???

s/<=>/$\\Leftrightarrow$/g
s/=>/$\\Rightarrow$/g
s/<->/$\\leftrightarrow$/g
s/->/$\\rightarrow$/g
s/<=/$\\leq$/g
s/>=/$\\geq$/g
s/=~/$\\simeq$/g
s/\/=/$\\neq$/g

# Traduction de `<' et `>'

# 4 cas :
# 1) on veut le caractre avec la police en cours : quoter avec < ou >
# 2) on veut les signes en mode math (typiquement dans du texte courant) :
#    les entourer d'au moins un espace

/ [<>] /{
          s/ < / $<$ /g
          s/ > / $>$ /g
          b suite
        }
# 3) on veut le signe en police tt (par exemple dans #include <stdio.h>)
#   il faut quoter par < et >
#   (le point centr "" s'obtient en mode diacritic par ".^")

# 4) on veut que latex rcupre < ou >, pour tre utilis dans une formule
# (package ifthen ...) : il suffit de ne pas mettre de blanc autour ou de forcer
# par < ou > (diacritic "X^") 

: suite

# Reprise des vrais \< \> \|

s//\\</g
s//\\>/g
s//\\|/g

# Abrviations de changements de polices : version avec `' au lieu de `%' !!!

# -- famille (family)

# R    ... r  : Roman                      \rmfamily
# S    ... s  : SansSerif                  \sffamily (ex %1 pour lq850)
# T    ... t  : Typewriter                 \ttfamily (ex %2 pour lq850)

s/[]R/\\textrm{/g
s/[]S/\\textsf{/g
s/[]T/\\texttt{/g

# -- graisse (series)

# AO    ... a : gras oblique               \bof (par dfaut \bfseries\sl)
# A     ... a : gras italique              \bif (par dfaut \bfseries\it)
# G     ... g : gras tendu (bx)           \boldseries
# BSvii ... b : gras sans serif taille 7 (36 pts)
# BS    ... b : gras sans serif            \bsf
# B     ... b : gras troit (b)            \bmf (par dfaut \usefont{T1}{cmr}{b}{n} )

# Mise en commentaire des commandes obsoltes
#s/[]AO/{\\bof /g
#s/[]A/{\\bif /g
s/[]G/{\\bfseries /g
#s/[]BSvii/{\\bsfvii /g
#s/[]BS/{\\bsf /g
#s/[]B/{\\bmf /g

# -- formes (shapes)

# I     ... i : Italic                     \itshape
# M     ... m : Majuscules (Small Caps)    \scshape   (ex %3 pour lq850)
# O     ... o : Oblique ou Slanted         \slshape   (ex %4 pour lq850)
# E     ... e : emphatique                 \em
# U     ... u : Unslanted (italic droit)   \upshape
# L     ... l : souLign                   \underline (ex %S pour lq850)
# N     ... n : normal embarqu            \ms\nf alias \mediumseries\normalfont

s/[]I/\\textit{/g
s/[]M/\\textsc{/g
s/[]O/\\textsl{/g
s/[]E/\\emph{/g
s/[]U/\\textup{/g
s/[]L/\\underline{/g
s/[]N/\\textmd{\\upshape /g

# -- Spcial pour programmes

# K: mot rserv                \kwd
# D: mot dclar                \dcl
# C: commentaire                \com ... \ecom

# -- terminateurs de polices

# [rstgbimoeulnkdc]             retour  la police englobante (traduit par `}')

s/[]K/{\\kwd /g
s/[]D/{\\dcl /g
s/[]C/{\\com /g
s/[]c/\\ecom}/g
s/[][rstagbimoeulnkd]/}/g

# Abrviations des changements de taille

s/\\t-4/\\tiny/g
s/\\t-3/\\scriptsize/g
s/\\t-2/\\footnotesize/g
s/\\t-1/\\small/g
s/\\t0/\\normalsize/g
s/\\t+1/\\large/g
s/\\t+2/\\Large/g
s/\\t+3/\\LARGE/g
s/\\t+4/\\huge/g
s/\\t+5/\\Huge/g

# Ajout des \\ dans les environnements verse, tabbing et programme
# Pour tabular,cela n'est pas conseill, car la complexit des lignes
#  crire ncessite de matriser les fin de lignes

/^[^%]*\\b[tv]/,/\\e[tv]/{
                        /\\[be][tv]/b s1
                        /\\kill/b s1
                        /\\newpage/b s1
                        s/$/\\\\/
                        }
/^[^%]*\\bP/,/\\eP/{
          /^\\vs/{
                    s/^[^{]*{\(.[^}]*\)}/[\1]/
                    b s1
                  }

# En pratique, lorsqu'on met une ligne blanche dans un programme, c'est
# toujours trop: 1/2 ligne suffit dans la plupart des cas
# Sinon, il suffit de mettre \vs{1\baselineskip} ou plus ...          

                  /^[	]*$/{
                              s/^/[\\halfline]/
                              b s1
                            }
                  /\\[be]P/b s1
                  /\\kill/b s1
                  /\\newpage/{
# newpage embarqu dans un programme
# Attention les tabulations doivent tre comme dans newprog.sty
# Latex n'accepte que 13 tabulations au plus !
# Nouvelle version janvier 96: on laisse telle que la ligne avec
# \newpage en dbut de ligne. 
# Ainsi, on peut placer ^\newpage\enlargethispage..
                        i\
                        \\end{tabbing}

# Ici est place la ligne avec \newpage...
                        a\
                        \\begin{tabbing}\
               mn\\=mn\\=mn\\=mn\\=mn\\=mm\\=mm\\=mm\\=mm\\=mmm\\=mmm\\=mmm\\=mmm\\=\\kill
                        b s1
                  }
                  s/$/\\\\/
             }

: s1

# 2 fois 3 cas factoriss : \bx$ \bxA-Z \bxa-z \ex$ \exA-Z \exa-z

s/\\b\([cdeiPqtTV]\)$/\\begin{\1}/g
s/\\b\([cdeiPqtTV]\)\([A-Z][A-Z]*\)/\\begin{\1\2}/g
s/\\b\([cdeiPqtTV]\)\([^a-z_]\)/\\begin{\1}\2/g
s/\\b\([cdeiPqtTV]\)\([[{]\)/\\begin{\1}\2/g
s/\\e\([cdeiPqtTV]\)$/\\end{\1}/g
s/\\e\([cdeiPqtTV]\)\([A-Z][A-Z]*\)/\\end{\1\2}/g
s/\\e\([cdeiPqtTV]\)\([^a-z_]\)/\\end{\1}\2/g
s/\\bmp/\\begin{minipage}/g
s/\\emp$/\\end{minipage}/g
s/\\emp\([^a-z]\)/\\end{minipage}\1/g

s/c/center/g
s/d/description/g
s/e/enumerate/g
s/i/itemize/g
s/P/program/g
s/q/quote/g
s/t/tabbing/g
s/T/tabular/g
s/V/verbatim/g

# traduction des sections sur une ligne, sans accolades

s/\\s0 \(.*\)/\\chapter{\1}/g
s/\\s1 \(.*\)/\\section{\1}/g
s/\\s2 \(.*\)/\\subsection{\1}/g
s/\\s3 \(.*\)/\\subsubsection{\1}/g
s/\\s4 \(.*\)/\\paragraph{\1}/g
s/\\s5 \(.*\)/\\subparagraph{\1}/g
s/\\s1\*\(.*\)/\\section*{\1}/g
s/\\s2\*\(.*\)/\\subsection*{\1}/g
s/\\s3\*\(.*\)/\\subsubsection*{\1}/g
s/\\s4\*\(.*\)/\\paragraph*{\1}/g
s/\\s5\*\(.*\)/\\subparagraph*{\1}/g

# Traduction des diacritiques (la plupart sont maintenant directement cods en 8 bits)

# - avec latex2e et les moteurs TeX 8 bits directement en iso-latin1 (frlatex, gutenberg)
# - mais cela reste ncessaire en mode tabbing et pour les i dans les titres !!!
#   Pour conomiser des rgles, on ne traduit que les lettres du franais:
#   dans les autres cas, utiliser les conventions explicites de latex

/\\begin{tabbing}/,/\\end{tabbing}/b tabbing
/\\begin{.*program.*}/,/\\end{.*program.*}/b tabbing

b suite3

# traductions des accents aigus et grave en mode tabbing
: tabbing
s//\\a`A/g
s//\\a'E/g
s//\\a`E/g
s//\\a`U/g
s//\\a`a/g
s//\\a'e/g
s//\\a`e/g
s//\\a`u/g
s/	/\\>/g

: suite3

# Encore un problme avec i dans les titres

s//\\^{\\i}/g
s//\\"{\\i}/g

# traduction des ligatures franaises : plus besoin d'inhibiteurs !

s/e/{\\oe}/g
s/E/{\\OE}/g
s//{\\ae}/g
s//{\\AE}/g

# Traduction de quelques symboles ISO-LATIN1 utiles :

# - s'il existe des macros Latex2e, alors traduction dans ces macros
# - sinon codage direct DC/T1/Cork (police Tex ou Postscript)

#--- Saisie de ces signes sous emacs ------------------------------------------

#  saisie par octal 253 ou diacritic <<
#  saisie par octal 273 ou diacritic >>
#  saisie par octal 247 ou diacritic S^
#  saisie par octal 266 ou diacritic P^
#  saisie par octal 241 ou diacritic !^
#  saisie par octal 277 ou diacritic ?^
#  saisie par octal 251 ou diacritic C^
#  saisie par octal 261 ou diacritic +Q^
#  saisie par octal 243 ou diacritic L^
#  saisie par octal 260 ou diacritic D^

# La traduction des   par << >> a l'avantage d'tre indpendante de
# l'encoding (beaucoup utilisent encore OT1), mais a l'inconvnient
# de dpendre de french. Si ncessaire. coder avec symbol dans le texte :
# \symbol{"13} et \symbol{"14} (cf Latex Companion p 341)

#s//<</g
#s//>>/g
s//\\S/g
#s//!`/g               # conomie
#s//?`/g               # conomie
s//\\copyright/g
s//$\\pm$/g
#s//\\pounds/g         # conomie
s//\\degree/g
s//\\Pisymbol{psy}{210}/g

# Traitement des lignes suite{} de transparents
/\\[Nn]sl[^{]*{.*\\suite{/i\
\\asuivre

# Traitement du `_'

# mode verbatim : laisser le `_' tel que
/\\begin{verbatim}/,/\\end{verbatim}/b fin

# autre modes : prfixer  par `\', sauf si le `_' est prcd d'un `\' ou `' ou suivi d'une `{'.
# deux substitutions sont ncessaires pour traiter les cas vicieux du genre aaa_a_bbb
s/\([^\\]\)_\([^{]\)/\1\\_\2/g
s/\([^\\]\)_\([^{]\)/\1\\_\2/g

: fin
# Caractre inhibiteur (void) -- @@  pour la compatibilit
s/[]//g

# Restauration des signes de commentaires de C, s'il en reste
s||/*|g
s||*/|g

#EOF a8_tex.sed

# provisoire bug de gsed nouvelle version
s/\\begin{enumerategin}/\\begin/g
s/\\end{centerom}//g
s/\\begin{itemizebliogr}/\\begin/g
s/\\beginaphystyle{/\\bibliographystyle{/g
s/\\beginaphy{/\\bibliography{/g
s/\\begin{enumerategingroup}/\\begingroup/g
s/\\end{itemizeffelcom}/\\eiffelcom/g

