/* utilitaire pour qu'un serveur de passage de fd qui
 * utilise le protocole de Stevens (send_fd/send_err/recv_fd)
 * envoie un message d'erreur et un code d'erreur au client.
 */

#include	<stevens.h>

int send_err(int clifd, int errcode, const char *msg) {
  /*  utiliser par un serveur pour envoyer sur la socket clifd d'un client
   * un message d'erreur msg et un code d'erreur errcode
   * qui seront traits par le client par recv_fd
   * retour: 0 si OK, -1 si erreur
   */
	int		n;

   /* si le msg est non nul l'envoyer par des write sur clifd */
	if ( (n = strlen(msg)) > 0)  /* writen est une primitive de Stevens */
	  if (writen(clifd, msg, n) != n) return(-1);

   /* il faut absolument que le code d'erreur soit ngatif */
	if (errcode >= 0) ERR_EXIT;

   /* envoyer le code d'erreur ngatif au client par le protocole
    * send_fd / recv-fd */
	if (send_fd(clifd, errcode) < 0) return(-1);
	return(0);
}
