#include "stevens.h"
#include	<stdarg.h>

/* Version RR de bufargs.c de Stevens */

int fetch_words (char *line, int max_nb_words, char *word1, ...){

/* Extrait de `line' (termine par '\n')
 * jusqu' max_nb_words mots spars par des espaces.
 * Rend ces mots (sans espace et termins par '\0') dans word1, ..., word_max.
 * Rend le nombre de mots lus, (max_nb_words +1 s'il y a plus de max_nb_words)
 */

   char     c;
   int      i;
   int      nb_words;
   char*    current_word;

   va_list  ap;

   /* mettre une chane vide dans chaque mot rsultat */
   *word1 = '\0';
   va_start(ap, word1);
   for ( i=2 ; i<=max_nb_words; i++){
     current_word = va_arg(ap, char*);
	  *current_word = '\0';
   }
   va_end(ap);

   /* lecture de l'word1 */
	i= 0;
	while ( ((c = *line++) != '\n') && (c != ' ')){
	  word1[i++] = c;
	}
	word1[i] = '\0';
   if ( c == '\n' ) return 1;
	/* limination des blancs de fin de ligne */
	while ( ((c = *line++) != '\n') && (c == ' '));
	if ( c == '\n' && i > 0 ) 
	  return 1;
   if ( c == '\n')
     return 0;

	/* lecture des mots suivants */
	va_start(ap, word1);
	for ( nb_words = 2 ; nb_words <= max_nb_words ; nb_words++){
	  i= 0;
	  line--;
	  current_word= va_arg(ap, char*);
	  while ( ((c = *line++) != '\n') && (c != ' ')){
		 current_word[i++] = c;
	  }
	  current_word[i] = '\0';
	  if ( c == '\n' ) return nb_words;
	  /* limination des blancs de fin de ligne */
	  while ( ((c = *line++) != '\n') && (c == ' '));
	  if ( c == '\n' && i >0 ) 
		 return nb_words;
	}
	 return nb_words;

}/* fetch_words */
