#include <stevens.h>

/* 
 * Creation d'une socket de server (socket)
 * de type stream/unix, attache (bind)  name dans la hirarchie.
 * attente qu'un client se manifeste (listen)
*/

int serv_listen(const char *name) {
   /* retourne le fd de la socket du serveur si OK, -1 si erreur */
   int fd;                        /* fd de la socket */
   struct sockaddr_un unix_addr;  /* adresse de la socket */ 
   int len;                       /* longueur de l'adresse Unix */

      /* creation d'une socket de domaine Unix de type stream */
   if ( (fd = socket(AF_UNIX, SOCK_STREAM, 0)) < 0) return(-1);

      /* effacement du nom, s'il existe avant binding */
   if ((unlink(name) <0) && (errno != ENOENT)){  /* un chec d'effacement */
      return(-2);
   }


      /* construire l'adresse de la socket du serveur et sa longueur */
   memset(&unix_addr, 0, sizeof(unix_addr)); /* mise  0 de tous les champs */
   unix_addr.sun_family = AF_UNIX;           /* type d'adresse */
   strcpy(unix_addr.sun_path, name);         /* recopie du nom de chemin */
   len = sizeof(unix_addr.sun_family) + strlen(unix_addr.sun_path) ;

       /* attacher la socket dans la hirarchie Unix */
   if (bind(fd, (struct sockaddr *) &unix_addr, len) < 0) return(-3);

      /* attendre jusqu' la connexion d'un client (au plus 5 en mme temps) */
   if (listen(fd, 5) < 0) return(-4);

      /* rendre le fd de la socket attache */
   return(fd);
}
