#include	<signal.h>
#include	<stevens.h>

/* @@RR static volatile sig_atomic_t	sigflag; */
static volatile int sigflag;
								/* set nonzero by signal handler */
static sigset_t			newmask, oldmask, zeromask;

static void
sig_usr(int signo)	/* one signal handler for SIGUSR1 and SIGUSR2 */
{
	sigflag = 1;
	return;
}

void
TELL_WAIT()
{
	if (signal(SIGUSR1, sig_usr) == SIG_ERR)
		errno_exit("signal(SIGINT) error");
	if (signal(SIGUSR2, sig_usr) == SIG_ERR)
		errno_exit("signal(SIGQUIT) error");

	sigemptyset(&zeromask);

	sigemptyset(&newmask);
	sigaddset(&newmask, SIGUSR1);
	sigaddset(&newmask, SIGUSR2);
		/* block SIGUSR1 and SIGUSR2, and save current signal mask */
	if (sigprocmask(SIG_BLOCK, &newmask, &oldmask) < 0)
		errno_exit("SIG_BLOCK error");
}

void
TELL_PARENT(pid_t pid)
{
	kill(pid, SIGUSR2);		/* tell parent we're done */
}

void
WAIT_PARENT(void)
{
	while (sigflag == 0)
		sigsuspend(&zeromask);	/* and wait for parent */

	sigflag = 0;
			/* reset signal mask to original value */
	if (sigprocmask(SIG_SETMASK, &oldmask, NULL) < 0)
		errno_exit("SIG_SETMASK error");
}
void
TELL_CHILD(pid_t pid)
{
	kill(pid, SIGUSR1);			/* tell child we're done */
}

void
WAIT_CHILD(void)
{
	while (sigflag == 0)
		sigsuspend(&zeromask);	/* and wait for child */

	sigflag = 0;
			/* reset signal mask to original value */
	if (sigprocmask(SIG_SETMASK, &oldmask, NULL) < 0)
		errno_exit("SIG_SETMASK error");
}

/* Noms en franais des primitives de Stevens */

void init_synchro (void){ TELL_WAIT(); }
void donne_feu_vert_pere (pid_t pid){ TELL_PARENT(pid); }
void donne_feu_vert_fils (pid_t pid){ TELL_CHILD(pid); }
void attend_feu_vert_dupere (void){ WAIT_PARENT(); }
void attend_feu_vert_dufils (void){ WAIT_CHILD(); }
